<template>
<section class="content">
    <div class="box box-info">
      <!-- <a href="#"   @click.prevent="exportCSV()" >
       <img src="../../../../static/img/excel.png" style="width: 4%;float: right;"/>
      </a>
       <div class="p-fluid p-formgrid p-grid">
            <div class="p-field p-col-12 p-md-1 p-mt-5">
              <Button @click.prevent="searchHouseHoldDetails"
                      class="p-button-rounded p-button-raised" label="Search" icon="pi pi-search"/>
            </div>
          </div> -->
           <div class="p-fluid p-formgrid p-grid">
          <div class="p-field p-col-12 p-col-12">
    <DataTable ref="po"
     dataKey="id"
      :value="apiLogsLists"
      :paginator="true"
      editMode="cell"
      :rows="10"  :filters="filters"
      :scrollable="true" scrollHeight="400px" scrollDirection="both">
      <Column header="S.n" >
      <template #body="slotProps">
        {{slotProps.index+1}}
      </template>
      </Column>

       <Column
        header="Date" :sortable="true"
        field="createdDate"
        filterMatchMode="contains"
      >
       <template #filter>
            <InputText type="text" class="p-column-filter" v-model="filters['createdDate']" />
        </template>
      </Column>
      <Column
        header="User Id" :sortable="true"
        field="enteredBy"
        filterMatchMode="contains"
      >
       <template #filter>
            <InputText type="text" class="p-column-filter" v-model="filters['enteredBy']" />
        </template>
      </Column>
      <Column
        header="Response Code" :sortable="true"
        field="responseCode"
        filterMatchMode="contains"
      >
       <template #filter>
            <InputText type="text" class="p-column-filter" v-model="filters['responseCode']" />
        </template>
      </Column>
     
      <Column :sortable="true" 
        header="Path"
        field="apiPath"
        filterMatchMode="contains"
      >
       <template #filter>
         <InputText type="text" class="p-column-filter" v-model="filters['apiPath']" />
       </template>
      </Column>
      <Column :sortable="true"  headerStyle="width:13em" header="Body" field="body" filterMatchMode="contains" >
      <template #filter>
        <InputText type="text" class="p-column-filter" v-model="filters['body']" />
      </template>
      </Column>
      <Column
        header="Response"
        field="response"
        filterMatchMode="contains"
      >
      <template #filter>
        <InputText type="text" class="p-column-filter" v-model="filters['response']" />
      </template>
      </Column>

    </DataTable>
          </div>
           </div>
  </div>
</section>
</template>
<script>
import DataTable from 'primevue/datatable'
import Column from 'primevue/column'
import Dialog from '../../layout/dialog'
import globalKey from '../../../store/globalKey'
import axios from 'axios'
import InputText from 'primevue/inputtext'
import Button from 'primevue/button'
// import $ from 'jquery'
import InputMask from 'primevue/inputmask'
import InputNumber from 'primevue/inputnumber'
export default {
  name: 'apiLogsLists',
  data () {
    return {
      dialogShow: false,
      id: '',
      columnList: '',
      filters: {},
      englishDateEnabled: true,
      fromDate: null,
      toDate: null
    }
  },
  components: {
    DataTable,
    Column,
    Dialog,
    InputText,
    Button,
    InputMask,
    InputNumber
  },
  computed: {
    apiLogsLists() {
      return this.$store.state.masterSetupData.apiLogsLists
    }
  },
  mounted() {
    this.apiLogsList()
    // this.columnNames()
    // this.checkEnglish()
    // if (!this.$store.getters.englishDate || this.$store.state.isEnglishDateEnabled === 'false') {
    //   this.nepaliDate()
    // }
    // if (!this.$store.getters.englishDate && this.salesChallan === undefined ||
    //   this.$store.state.isEnglishDateEnabled === 'false') {
    //   this.setNepaliDate()
    // }
    // if (this.$store.state.isEnglishDateEnabled && this.$store.state.isEnglishDateEnabled !== 'false') {
    //   this.setEnglishDate()
    // }
  },
  methods: {
    async apiLogsList() {
      try {
        await this.$store.dispatch('loadApiLogs')
      } catch (e) {}
    },
    async searchHouseHoldDetails() {
      this.loading = !this.loading
      let resp = await this.$store.dispatch('loadHouseHoldDetailsReport')
      this.loading = false
      if (resp.data.data.length <= 0) {
        this.$toast.add({severity: 'error', summary: '', detail: 'Sorry! No data available.', life: 10000})
      }
    },
    editAgencyRecord(data) {
      this.$emit('editAgencyRecord', data)
    },
    async deleteAgencyRecord(value) {
      if (value.trim() === '') {
        let message = {
          message: 'Delete Reason cannot be empty.',
          messageType: 'error'
        }
        this.$emit('delete-message', message)
        this.dialogShow = true
        return
      }
      let deleteRe = {
        accountMasterId: this.accountId,
        deleteReason: value
      }
      try {
        let resp = await this.$store.dispatch('deleteAgencyRecord', deleteRe)
        if (resp.data.status === 'SUCCESS') {
          let message = {
            message: resp.data.message,
            messageType: 'success'
          }
          this.$emit('delete-message', message)
        } else {
          let message = {
            message: resp.data.message,
            messageType: 'error'
          }
          this.$emit('delete-message', message)
        }
      } catch (e) {
        let message = {
          message: 'Something went wrong!!',
          messageType: 'error'
        }
        this.$emit('delete-message', message)
      }

      this.closeDialog()
    },
    async updateTextureFormReport(data) {
      let tes = {
        id: data.id,
        texture: data.texture,
        ph: data.ph
      }
      let resp = await this.$store.dispatch('updateTexture', tes)
      if (resp.data.status === 'SUCCESS') {
        this.$toast.add({severity: 'success', summary: '', detail: resp.data.message, life: 10000})
        this.reason = ''
        this.ecommerceStatusDialog = false
      }
    },
    exportCSV() {
      let data = {
        columnList: this.columnList,
        toDate: this.toDate,
        fromDate: this.fromDate
      }
      axios({
        url: globalKey + '/fileDownload/excelReport' + '/' + this.$store.getters.userId + '/' + data.fromDate + '/' + data.toDate + '/' + 'SoilAnalysis' + '/' + this.$store.getters.fyId + '/' + data.columnList,
        method: 'get',
        headers: { 'Accept': 'application/vnd.ms-excel', 'Authorization': localStorage.token },
        responseType: 'blob'
      }).then((response) => {
        const url = window.URL.createObjectURL(new Blob([response.data]), {type: response.data.type})
        const link = document.createElement('a')
        const contentDisposition = response.headers['content-disposition']
        let fileName = 'soilAnalysisReport.xlsx'
        if (contentDisposition) {
          const fileNameMatch = contentDisposition.match(/filename="(.+)"/)
          if (fileNameMatch.length === 2) {
            fileName = fileNameMatch[1]
          }
        }
        link.href = url
        link.setAttribute('download', fileName)
        document.body.appendChild(link)
        link.click()
        link.remove()
        window.URL.revokeObjectURL(url)
      })
    },
    // setNepaliDate() {
    //   if (this.$store.getters.nepaliNewDate !== '') {
    //     this.fromDate = this.$store.getters.nepaliNewDate
    //     this.toDate = this.$store.getters.nepaliNewDate
    //   }
    // },
    // setEnglishDate() {
    //   this.fromDate = new Date().toISOString().slice(0, 10)
    //   this.toDate = new Date().toISOString().slice(0, 10)
    // },
    // checkEnglish() {
    //   if (this.$store.state.isEnglishDateEnabled === false || this.$store.state.isEnglishDateEnabled === 'false') {
    //     this.englishDateEnabled = true
    //     return
    //   } else {
    //     this.englishDateEnabled = false
    //     return
    //   }
    // },
    // nepaliDate() {
    //   $('#fromDate').nepaliDatePicker({
    //     ndpYear: true,
    //     ndpMonth: true,
    //     ndpYearCount: 10,
    //     disableBefore: this.$store.state.startDate,
    //     disableAfter: this.$store.state.endDate,
    //     onChange: () => {
    //       this.fromDate = $('#fromDate').val()
    //     }
    //   })
    //   $('#toDate').nepaliDatePicker({
    //     ndpYear: true,
    //     ndpMonth: true,
    //     ndpYearCount: 10,
    //     disableBefore: this.$store.state.startDate,
    //     disableAfter: this.$store.state.endDate,
    //     onChange: () => {
    //       this.toDate = $('#toDate').val()
    //     }
    //   })
    // },
    // columnNames() {
    //   for (let i = 0; i < this.$refs.po.columns.length; i++) {
    //     this.columnList += this.$refs.po.columns[i].header + ','
    //   }
    // },
    cancel(data) {
      this.dialogShow = false
    },
    openDialog(id) {
      this.dialogShow = true
      this.id = id
    },
    closeDialog() {
      this.dialogShow = false
    },
    async deleteReport(value) {
      if (value.trim() === '') {
        let message = {
          message: 'Delete Reason cannot be empty.',
          messageType: 'error'
        }
        this.$emit('delete-message', message)
        this.dialogShow = true
        return
      }
      let deleteRe = {
        id: this.id,
        deleteReason: value
      }
      try {
        let resp = await this.$store.dispatch('deleteReport', deleteRe)
        if (resp.data.status === 'SUCCESS') {
          let message = {
            message: resp.data.message,
            messageType: 'success'
          }
          this.$emit('delete-message', message)
        } else {
          let message = {
            message: resp.data.message,
            messageType: 'warn'
          }
          this.$emit('delete-message', message)
        }
      } catch (e) {
        let message = {
          message: 'Something went wrong!!',
          messageType: 'error'
        }
        this.$emit('delete-message', message)
        return
      }

      this.closeDialog()
    }
  }
}
</script>

<style>

</style>
